+2009-01-19 Martin Lambers <marlam@marlam.de>
+
+ * modules/link-tests: New file.
+ * tests/test-link.sh: New file.
+ * tests/test-link.c: New file.
+
2009-01-19 Eric Blake <ebb9@byu.net>
doc: mention another function added in cygwin 1.7.0
--- /dev/null
+Files:
+tests/test-link.sh
+tests/test-link.c
+
+Depends-on:
+
+configure.ac:
+
+Makefile.am:
+TESTS += test-link.sh
+TESTS_ENVIRONMENT += EXEEXT='@EXEEXT@'
+check_PROGRAMS += test-link
--- /dev/null
+/* Test of link() function.
+ Copyright (C) 2009 Free Software Foundation, Inc.
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>. */
+
+#include <config.h>
+
+#include <unistd.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#define ASSERT(expr) \
+ do \
+ { \
+ if (!(expr)) \
+ { \
+ fprintf (stderr, "%s:%d: assertion failed\n", __FILE__, __LINE__); \
+ fflush (stderr); \
+ abort (); \
+ } \
+ } \
+ while (0)
+
+int
+main (int argc, char **argv)
+{
+ ASSERT (argc == 3);
+ ASSERT (link (argv[1], argv[2]) == 0);
+
+ return 0;
+}
--- /dev/null
+#!/bin/sh
+
+tmpfiles="test-link-a.txt test-link-b.txt test-link-c.txt"
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+# Create a file.
+echo "hello" > test-link-a.txt || exit 1
+
+# Use link() to create a new name for it.
+./test-link${EXEEXT} test-link-a.txt test-link-b.txt || exit 1
+cmp test-link-a.txt test-link-b.txt || exit 1
+
+# Modify the contents of the first file.
+echo "world" >> test-link-a.txt || exit 1
+cmp test-link-a.txt test-link-b.txt || exit 1
+
+# Modify the contents of the second file.
+echo "some text" >> test-link-b.txt || exit 1
+cmp test-link-a.txt test-link-b.txt || exit 1
+
+# Delete the first file, then verity the second file still has the same
+# contents.
+cp test-link-a.txt test-link-c.txt || exit 1
+rm test-link-a.txt || exit 1
+cmp test-link-b.txt test-link-c.txt || exit 1
+
+rm -fr $tmpfiles
+exit 0